include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
include "relations.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_prop : \forall (return_:nat -> Prop). (return_ (O) ) -> (\forall (n:nat). return_ ((S)  n)) -> \forall (z:nat). return_ z.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O.
definition eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
definition pred : nat -> nat := \lambda n : nat. (match_nat_type) (nat) (O)  (\lambda p : nat. p) n.
definition not_zero : nat -> Prop := \lambda n : nat. (match_nat_type) (Prop) (False)  (\lambda p : nat. (True) ) n.
axiom le : nat -> nat -> Prop.
axiom le_n : \forall (n:nat). (le)  n n.
axiom le_S : \forall (n:nat). \forall (m:nat). ((le)  n m) -> (le)  n ((S)  m).
axiom le_ind : \forall (n:nat). \forall (Q:nat -> Prop). (Q n) -> (\forall (m:nat). ((le)  n m) -> (Q m) -> Q ((S)  m)) -> \forall (m:nat). ((le)  n m) -> Q m.
definition lt : nat -> nat -> Prop := \lambda n : nat. \lambda m : nat. (le)  ((S)  n) m.
definition nat_elim2 : \forall (R:nat -> nat -> Prop). (\forall (n:nat). R (O)  n) -> (\forall (n:nat). R ((S)  n) (O) ) -> (\forall (n:nat). \forall (m:nat). (R n m) -> R ((S)  n) ((S)  m)) -> \forall (n:nat). \forall (m:nat). R n m := \lambda R : nat -> nat -> Prop. \lambda ROn : \forall (n:nat). R (O)  n. (\lambda RSO : \forall (n:nat). R ((S)  n) (O) . (\lambda RSS : \forall (n:nat). \forall (m:nat). (R n m) -> R ((S)  n) ((S)  m). (\lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. \forall (m:nat). R j_x_365 m)) (\lambda m : nat. (ROn) (m))) (\lambda n0 : nat. \lambda Rn0m : \forall (m:nat). R n0 m. (\lambda m : nat. ((((match_nat_prop) (\lambda j__ : nat. R ((S)  n0) j__)) ((RSO) (n0))) (\lambda auto : nat. (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
definition pred_Sn : \forall (n:nat). (eq) (nat) n ((pred)  ((S)  n)) := \lambda n : nat. ((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (n)) (\lambda y : nat. (eq) (nat) n y)) (((refl) (nat)) (n)).
definition lt_to_not_zero : \forall (n:nat). \forall (m:nat). ((lt)  n m) -> (not_zero)  m := \lambda n : nat. \lambda m : nat. \lambda Hlt : (lt)  n m. (((((((le_ind) ((S)  n)) (\lambda x_417 : nat. (not_zero)  x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) ((False) )) (\lambda p : nat. (True) )) (n)) (\lambda y : Prop. y)) (I))) (\lambda m0 : nat. \lambda j_x_419 : (le)  ((S)  n) m0. (\lambda j_x_421 : (not_zero)  m0. (((((((sym_eq_match_nat_type_S) (Prop)) ((False) )) (\lambda p : nat. (True) )) (m0)) (\lambda y : Prop. y)) (I))))) (m)) (Hlt)).
definition le_n_Sn : \forall (n:nat). (le)  n ((S)  n) := \lambda n : nat. (((le_S) (n)) (n)) ((le_n) (n)).
definition transitive_le : (transitive) (nat) (le)  := \lambda a : nat. \lambda b : nat. \lambda c : nat. \lambda leab : (le)  a b. (\lambda lebc : (le)  b c. (((((((le_ind) (b)) (\lambda x_417 : nat. (le)  a x_417)) (leab)) (\lambda m : nat. \lambda j_x_419 : (le)  b m. (\lambda j_x_421 : (le)  a m. ((((le_S) (a)) (m)) (j_x_421))))) (c)) (lebc))).
definition le_pred_n : \forall (n:nat). (le)  ((pred)  n) n := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. (le)  ((pred)  j_x_365) j_x_365)) ((((((eq_match_nat_type_O) (nat)) ((O) )) (\lambda p : nat. p)) (\lambda y : nat. (le)  ((match_nat_type) (nat) (O)  (\lambda p : nat. p) (O) ) y)) ((le_n) ((pred)  (O) )))) (\lambda x_366 : nat. \lambda j_x_368 : (le)  ((pred)  x_366) x_366. (((((((eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (x_366)) (\lambda y : nat. (le)  ((pred)  ((S)  x_366)) ((S)  y))) ((le_n_Sn) ((pred)  ((S)  x_366)))))) (n).
definition monotonic_pred : (monotonic) (nat) (le)  (pred)  := \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (((((((le_ind) (n)) (\lambda x_417 : nat. (le)  ((pred)  n) ((pred)  x_417))) ((le_n) ((pred)  n))) (\lambda m0 : nat. \lambda j_x_419 : (le)  n m0. (\lambda j_x_421 : (le)  ((pred)  n) ((pred)  m0). ((((((transitive_le) ((pred)  n)) (n)) ((pred)  ((S)  m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (m0)) (\lambda y : nat. (le)  n y)) (j_x_419)))))) (m)) (lenm)).
definition not_le_Sn_O : \forall (n:nat). (Not)  ((le)  ((S)  n) (O) ) := \lambda n : nat. ((nmk) ((le)  ((S)  n) (O) )) (\lambda Hlen0 : (le)  ((S)  n) (O) . ((((((eq_match_nat_type_O) (Prop)) ((False) )) (\lambda p : nat. (True) )) (\lambda y : Prop. y)) ((((lt_to_not_zero) (n)) ((O) )) (Hlen0)))).
definition le_n_O_to_eq : \forall (n:nat). ((le)  n (O) ) -> (eq) (nat) (O)  n := \lambda n : nat. ((((match_nat_prop) (\lambda j__ : nat. ((le)  j__ (O) ) -> (eq) (nat) (O)  j__)) (\lambda auto : (le)  (O)  (O) . (((refl) (nat)) ((O) )))) (\lambda a : nat. \lambda abs : (le)  ((S)  a) (O) . (((falsity) ((eq) (nat) (O)  ((S)  a))) ((((absurd) ((le)  ((S)  a) (O) )) (abs)) ((not_le_Sn_O) (a)))))) (n).
definition le_to_le_to_eq : \forall (n:nat). \forall (m:nat). ((le)  n m) -> ((le)  m n) -> (eq) (nat) n m := ((((nat_elim2) (\lambda j__ : nat. \lambda j_0 : nat. ((le)  j__ j_0) -> ((le)  j_0 j__) -> (eq) (nat) j__ j_0)) (\lambda n : nat. \lambda auto : (le)  (O)  n. (\lambda auto' : (le)  n (O) . (((((sym_eq) (nat)) (n)) ((O) )) (((((sym_eq) (nat)) ((O) )) (n)) (((((eq_coerc) ((eq) (nat) (O)  n)) ((eq) (nat) (O)  n)) (((le_n_O_to_eq) (n)) (auto'))) (((refl) (Prop)) ((eq) (nat) (O)  n)))))))) (\lambda n : nat. \lambda auto : (le)  ((S)  n) (O) . (\lambda auto' : (le)  (O)  ((S)  n). (((((sym_eq) (nat)) ((O) )) ((S)  n)) (((le_n_O_to_eq) ((S)  n)) (auto)))))) (\lambda n : nat. \lambda m : nat. \lambda auto : ((le)  n m) -> ((le)  m n) -> (eq) (nat) n m. (\lambda auto' : (le)  ((S)  n) ((S)  m). (\lambda auto'' : (le)  ((S)  m) ((S)  n). (((((((eq_f) (nat)) (nat)) ((S) )) (n)) (m)) (((auto) (((((eq_coerc) ((le)  ((pred)  ((S)  n)) ((pred)  ((S)  m)))) ((le)  n m)) ((((monotonic_pred) ((S)  n)) ((S)  m)) (auto'))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((pred)  ((S)  m))) ((le)  n m))) (((((((rewrite_l) (nat)) (m)) (\lambda j__ : nat. (eq) (Prop) ((le)  n j__) ((le)  n m))) (((refl) (Prop)) ((le)  n m))) ((pred)  ((S)  m))) ((pred_Sn) (m)))) ((pred)  ((S)  n))) ((pred_Sn) (n))))) (((((eq_coerc) ((le)  ((pred)  ((S)  m)) ((pred)  ((S)  n)))) ((le)  m n)) ((((monotonic_pred) ((S)  m)) ((S)  n)) (auto''))) (((((((rewrite_l) (nat)) (m)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((pred)  ((S)  n))) ((le)  m n))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  m j__) ((le)  m n))) (((refl) (Prop)) ((le)  m n))) ((pred)  ((S)  n))) ((pred_Sn) (n)))) ((pred)  ((S)  m))) ((pred_Sn) (m))))))))).
